/**********************************************************************
 *  
 *  aztecsub.c
 *  
 *  copyright (c) 1988,89,90 J. Alan Eldridge
 *
 *  subroutine(s) needed by Curses which Aztec C does not supply
 *  
 *********************************************************************/

#include "curses.h"

#include <stdarg.h>

#if AZTEC

/**********************************************************************
 *  
 *  vsprintf()
 *  
 *  like sprintf(), except gets a pointer to the args
 *  
 *********************************************************************/

static char *cp;

static int
sputc(int c)
{
    *cp++ = c;
}
    
int
vsprintf(
    char    *buf,
    char    *fmt,
    va_list args)
{
    cp = buf;
    return format(sputc, fmt, args);
}

#endif  /* AZTEC */
